Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/DiscriminantFunctionClassificationRocCurvesView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/DiscriminantFunctionClassificationRocCurvesView.cs	(revision 6911)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/DiscriminantFunctionClassificationRocCurvesView.cs	(revision 6912)
@@ -140,6 +140,6 @@
 
               ROCPoint rocPoint = new ROCPoint(truePositiveRate, falsePositiveRate, lowerThreshold, upperThreshold);
-              if (!rocPoints.Any(x => x.truePositiveRate >= rocPoint.truePositiveRate && x.falsePositiveRate <= rocPoint.falsePositiveRate)) {
-                rocPoints.RemoveAll(x => x.falsePositiveRate >= rocPoint.falsePositiveRate && x.truePositiveRate <= rocPoint.truePositiveRate);
+              if (!rocPoints.Any(x => x.TruePositiveRate >= rocPoint.TruePositiveRate && x.FalsePositiveRate <= rocPoint.FalsePositiveRate)) {
+                rocPoints.RemoveAll(x => x.FalsePositiveRate >= rocPoint.FalsePositiveRate && x.TruePositiveRate <= rocPoint.TruePositiveRate);
                 rocPoints.Add(rocPoint);
               }
@@ -150,5 +150,5 @@
 
           string className = Content.ProblemData.ClassNames.ElementAt(classValues.IndexOf(classValue));
-          cachedRocPoints[className] = rocPoints.OrderBy(x => x.falsePositiveRate).ToList(); ;
+          cachedRocPoints[className] = rocPoints.OrderBy(x => x.FalsePositiveRate).ToList(); ;
 
           Series series = new Series(className);
@@ -169,13 +169,13 @@
       foreach (ROCPoint rocPoint in rocPoints) {
         DataPoint point = new DataPoint();
-        point.XValue = rocPoint.falsePositiveRate;
-        point.YValues[0] = rocPoint.truePositiveRate;
+        point.XValue = rocPoint.FalsePositiveRate;
+        point.YValues[0] = rocPoint.TruePositiveRate;
         point.Tag = rocPoint;
 
         StringBuilder sb = new StringBuilder();
-        sb.AppendLine("True Positive Rate: " + rocPoint.truePositiveRate);
-        sb.AppendLine("False Positive Rate: " + rocPoint.falsePositiveRate);
-        sb.AppendLine("Upper Threshold: " + rocPoint.upperThreshold);
-        sb.AppendLine("Lower Threshold: " + rocPoint.lowerThreshold);
+        sb.AppendLine("True Positive Rate: " + rocPoint.TruePositiveRate);
+        sb.AppendLine("False Positive Rate: " + rocPoint.FalsePositiveRate);
+        sb.AppendLine("Upper Threshold: " + rocPoint.UpperThreshold);
+        sb.AppendLine("Lower Threshold: " + rocPoint.LowerThreshold);
         point.ToolTip = sb.ToString();
 
@@ -249,14 +249,14 @@
     private class ROCPoint {
       public ROCPoint(double truePositiveRate, double falsePositiveRate, double lowerThreshold, double upperThreshold) {
-        this.truePositiveRate = truePositiveRate;
-        this.falsePositiveRate = falsePositiveRate;
-        this.lowerThreshold = lowerThreshold;
-        this.upperThreshold = upperThreshold;
-
-      }
-      public double truePositiveRate { get; private set; }
-      public double falsePositiveRate { get; private set; }
-      public double lowerThreshold { get; private set; }
-      public double upperThreshold { get; private set; }
+        this.TruePositiveRate = truePositiveRate;
+        this.FalsePositiveRate = falsePositiveRate;
+        this.LowerThreshold = lowerThreshold;
+        this.UpperThreshold = upperThreshold;
+
+      }
+      public double TruePositiveRate { get; private set; }
+      public double FalsePositiveRate { get; private set; }
+      public double LowerThreshold { get; private set; }
+      public double UpperThreshold { get; private set; }
     }
 
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Persistence-3.3/UseCases.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Persistence-3.3/UseCases.cs	(revision 6911)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Persistence-3.3/UseCases.cs	(revision 6912)
@@ -40,4 +40,5 @@
 using HeuristicLab.Persistence.Default.Xml.Primitive;
 using HeuristicLab.Persistence.Interfaces;
+using HeuristicLab_33.Tests;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
@@ -532,5 +533,5 @@
       List<string> lowerCaseProperties = new List<string>();
       List<string> lowerCaseFields = new List<string>();
-      foreach (Assembly a in AppDomain.CurrentDomain.GetAssemblies()) {
+      foreach (Assembly a in PluginLoader.Assemblies) {
         if (!a.GetName().Name.StartsWith("HeuristicLab"))
           continue;